<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'RIS_Message_Type' => '\\StructType\\RIS_Message_Type',
            'identification_type' => '\\StructType\\Identification_type',
            'ftm_type' => '\\StructType\\Ftm_type',
            'communication_type' => '\\StructType\\Communication_type',
            'object_type' => '\\StructType\\Object_type',
            'wrm_type' => '\\StructType\\Wrm_type',
            'measure_type' => '\\StructType\\Measure_type',
            'difference_type' => '\\StructType\\Difference_type',
            'icem_type' => '\\StructType\\Icem_type',
            'ice_condition_type' => '\\StructType\\Ice_condition_type',
            'werm_type' => '\\StructType\\Werm_type',
            'fairway_section_werm_type' => '\\StructType\\Fairway_section_werm_type',
            'weather_report_type' => '\\StructType\\Weather_report_type',
            'weather_item_type' => '\\StructType\\Weather_item_type',
            'nts_number_type' => '\\StructType\\Nts_number_type',
            'validity_period_type' => '\\StructType\\Validity_period_type',
            'fairway_section_type' => '\\StructType\\Fairway_section_type',
            'geo_object_type' => '\\StructType\\Geo_object_type',
            'coordinate_type' => '\\StructType\\Coordinate_type',
            'limitation_type' => '\\StructType\\Limitation_type',
            'limitation_period_type' => '\\StructType\\Limitation_period_type',
            'target_group_type' => '\\StructType\\Target_group_type',
            'get_messages_query' => '\\StructType\\Get_messages_query',
            'get_messages_result' => '\\StructType\\Get_messages_result',
            'id_pair' => '\\StructType\\Id_pair',
            'date_pair' => '\\StructType\\Date_pair',
        );
    }
}
