<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for get_messages_result StructType
 * @subpackage Structs
 */
class Get_messages_result extends AbstractStructBase
{
    /**
     * The result_message
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RIS_Message_Type[]
     */
    public $result_message;
    /**
     * The result_error
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $result_error;
    /**
     * The paging_result
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var paging_result_type
     */
    public $paging_result;
    /**
     * Constructor method for get_messages_result
     * @uses Get_messages_result::setResult_message()
     * @uses Get_messages_result::setResult_error()
     * @uses Get_messages_result::setPaging_result()
     * @param \StructType\RIS_Message_Type[] $result_message
     * @param string[] $result_error
     * @param paging_result_type $paging_result
     */
    public function __construct(array $result_message = array(), array $result_error = array(), paging_result_type $paging_result = null)
    {
        $this
            ->setResult_message($result_message)
            ->setResult_error($result_error)
            ->setPaging_result($paging_result);
    }
    /**
     * Get result_message value
     * @return \StructType\RIS_Message_Type[]|null
     */
    public function getResult_message()
    {
        return $this->result_message;
    }
    /**
     * This method is responsible for validating the values passed to the setResult_message method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResult_message method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResult_messageForArrayConstraintsFromSetResult_message(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $get_messages_resultResult_messageItem) {
            // validation for constraint: itemType
            if (!$get_messages_resultResult_messageItem instanceof \StructType\RIS_Message_Type) {
                $invalidValues[] = is_object($get_messages_resultResult_messageItem) ? get_class($get_messages_resultResult_messageItem) : sprintf('%s(%s)', gettype($get_messages_resultResult_messageItem), var_export($get_messages_resultResult_messageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The result_message property can only contain items of type \StructType\RIS_Message_Type, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set result_message value
     * @throws \InvalidArgumentException
     * @param \StructType\RIS_Message_Type[] $result_message
     * @return \StructType\Get_messages_result
     */
    public function setResult_message(array $result_message = array())
    {
        // validation for constraint: array
        if ('' !== ($result_messageArrayErrorMessage = self::validateResult_messageForArrayConstraintsFromSetResult_message($result_message))) {
            throw new \InvalidArgumentException($result_messageArrayErrorMessage, __LINE__);
        }
        $this->result_message = $result_message;
        return $this;
    }
    /**
     * Add item to result_message value
     * @throws \InvalidArgumentException
     * @param \StructType\RIS_Message_Type $item
     * @return \StructType\Get_messages_result
     */
    public function addToResult_message(\StructType\RIS_Message_Type $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RIS_Message_Type) {
            throw new \InvalidArgumentException(sprintf('The result_message property can only contain items of type \StructType\RIS_Message_Type, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->result_message[] = $item;
        return $this;
    }
    /**
     * Get result_error value
     * @return string[]|null
     */
    public function getResult_error()
    {
        return $this->result_error;
    }
    /**
     * This method is responsible for validating the values passed to the setResult_error method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResult_error method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResult_errorForArrayConstraintsFromSetResult_error(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $get_messages_resultResult_errorItem) {
            // validation for constraint: enumeration
            if (!\EnumType\Error_code_type::valueIsValid($get_messages_resultResult_errorItem)) {
                $invalidValues[] = is_object($get_messages_resultResult_errorItem) ? get_class($get_messages_resultResult_errorItem) : sprintf('%s(%s)', gettype($get_messages_resultResult_errorItem), var_export($get_messages_resultResult_errorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\Error_code_type', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\Error_code_type::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set result_error value
     * @uses \EnumType\Error_code_type::valueIsValid()
     * @uses \EnumType\Error_code_type::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $result_error
     * @return \StructType\Get_messages_result
     */
    public function setResult_error(array $result_error = array())
    {
        // validation for constraint: array
        if ('' !== ($result_errorArrayErrorMessage = self::validateResult_errorForArrayConstraintsFromSetResult_error($result_error))) {
            throw new \InvalidArgumentException($result_errorArrayErrorMessage, __LINE__);
        }
        $this->result_error = $result_error;
        return $this;
    }
    /**
     * Add item to result_error value
     * @uses \EnumType\Error_code_type::valueIsValid()
     * @uses \EnumType\Error_code_type::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\Get_messages_result
     */
    public function addToResult_error($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\Error_code_type::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\Error_code_type', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\Error_code_type::getValidValues())), __LINE__);
        }
        $this->result_error[] = $item;
        return $this;
    }
    /**
     * Get paging_result value
     * @return paging_result_type|null
     */
    public function getPaging_result()
    {
        return $this->paging_result;
    }
    /**
     * Set paging_result value
     * @param paging_result_type $paging_result
     * @return \StructType\Get_messages_result
     */
    public function setPaging_result(paging_result_type $paging_result = null)
    {
        $this->paging_result = $paging_result;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Get_messages_result
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
