<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for validity_period_type StructType
 * @subpackage Structs
 */
class Validity_period_type extends AbstractStructBase
{
    /**
     * The date_start
     * Meta information extracted from the WSDL
     * - documentation: Start date of validity period including time zone
     * @var string
     */
    public $date_start;
    /**
     * The date_end
     * Meta information extracted from the WSDL
     * - documentation: End date of validity period including time zone
     * - minOccurs: 0
     * @var string
     */
    public $date_end;
    /**
     * Constructor method for validity_period_type
     * @uses Validity_period_type::setDate_start()
     * @uses Validity_period_type::setDate_end()
     * @param string $date_start
     * @param string $date_end
     */
    public function __construct($date_start = null, $date_end = null)
    {
        $this
            ->setDate_start($date_start)
            ->setDate_end($date_end);
    }
    /**
     * Get date_start value
     * @return string|null
     */
    public function getDate_start()
    {
        return $this->date_start;
    }
    /**
     * Set date_start value
     * @param string $date_start
     * @return \StructType\Validity_period_type
     */
    public function setDate_start($date_start = null)
    {
        // validation for constraint: string
        if (!is_null($date_start) && !is_string($date_start)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date_start, true), gettype($date_start)), __LINE__);
        }
        $this->date_start = $date_start;
        return $this;
    }
    /**
     * Get date_end value
     * @return string|null
     */
    public function getDate_end()
    {
        return $this->date_end;
    }
    /**
     * Set date_end value
     * @param string $date_end
     * @return \StructType\Validity_period_type
     */
    public function setDate_end($date_end = null)
    {
        // validation for constraint: string
        if (!is_null($date_end) && !is_string($date_end)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date_end, true), gettype($date_end)), __LINE__);
        }
        $this->date_end = $date_end;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Validity_period_type
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
